"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _slonik = require("slonik");

var _default = async connection => {
  return connection.any(_slonik.sql`
    SELECT
      c1.relname "tableName",
      c2.relname "indexName",
      i1.indisunique "indexIsUnique",
      array_agg(a1.attname)::text[] "columnNames"
    FROM
      pg_class c1,
      pg_class c2,
      pg_index i1,
      pg_attribute a1
    WHERE
      c1.oid = i1.indrelid
      AND c2.oid = i1.indexrelid
      AND a1.attrelid = c1.oid
      AND a1.attnum = ANY(i1.indkey)
      AND c1.relkind IN ('r', 'm')
    GROUP BY
      c1.relname,
      c2.relname,
      i1.indisunique
    ORDER BY
      c1.relname,
      c2.relname
  `);
};

exports.default = _default;
//# sourceMappingURL=getDatabaseIndexes.js.map