"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _Logger = _interopRequireDefault(require("../Logger"));

var _isNumberType = _interopRequireDefault(require("./isNumberType"));

var _isStringType = _interopRequireDefault(require("./isStringType"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const log = _Logger.default.child({
  namespace: 'getFlowType'
});

var _default = databaseTypeName => {
  if (databaseTypeName === 'json') {
    return 'Object';
  }

  if (databaseTypeName === 'boolean') {
    return 'boolean';
  }

  if ((0, _isStringType.default)(databaseTypeName)) {
    return 'string';
  }

  if ((0, _isNumberType.default)(databaseTypeName)) {
    return 'number';
  }

  if (databaseTypeName === 'json' || databaseTypeName === 'jsonb') {
    return 'Object';
  }

  log.warn({
    databaseTypeName
  }, 'unknown type');
  return 'any';
};

exports.default = _default;
//# sourceMappingURL=getFlowType.js.map